function Polygons = Polygons(Rectangles, size)
%%%Computes all polygons up to degree 4 for the Rectangles.
%%%Encode it as: [a,b,c,d] where the integers denote the rectangles with
%%%corresponding orientation.

Polygons = [0,0,0,0];

l_rect = length(Rectangles);
for i1=1:l_rect
    %%%first the case that the first rectangle has positive orientation
    sign1 = 1;
    r1_temp = Rectangles(i1,:);
    for i2 = (i1+1):l_rect
        %%%Check if one of the orientations of the rectangle 2 agrees?
        %%%check if r
        if(following(r1_temp,Rectangles(i2,:),size)==1)
            r2_temp = Rectangles(i2,:);
            sign2 = 1;
        elseif(following(r1_temp,rectangle_flip(Rectangles(i2,:)),size)==1)
            r2_temp = rectangle_flip(Rectangles(i2,:));
            sign2 = -1;
        else continue;
        end%%there are no matches!
        %%%Now: check if this already is a match!
        if(following(r2_temp,r1_temp,size)==1)
            %%%Found a Polygon of degree 2;
            p_temp = [sign1*i1, sign2*i2, 0,0];
            Polygons = [Polygons;p_temp];
            continue;
        end%%look for another match!
        
         %%%maybe there is a polygon of degree 3?
            for i3 = i1:l_rect
                %%%%check if i3 follows r3?
                if(following(r2_temp,Rectangles(i3,:),size)==1)
                    r3_temp = Rectangles(i3,:);
                    sign3 = 1;
                elseif(following(r2_temp,rectangle_flip(Rectangles(i3,:)),size)==1)
                    r3_temp = rectangle_flip(Rectangles(i3,:));
                    sign3 = -1;
                else continue; %%there are no matches!
                end
                %%%Here: there are matches, so look for them!
                if(following(r3_temp,r1_temp,size)==1)
                    %%%Found a Polygon of degree 3;
                    p_temp = [sign1*i1, sign2*i2, sign3*i3,0];
                        Polygons = [Polygons;p_temp];
                    continue;
                end%%look for another match!
                 %%%maybe there is a polygon of degree 4?
                    
                    
                     for i4 = i1:l_rect
                %%%%check if i4 follows r3?
                        r_flip_temp4 = rectangle_flip(Rectangles(i4,:)); %%%maybe it is more efficient to save the r_flip in advance
                        if(following(r3_temp,Rectangles(i4,:),size)==1)
                            r4_temp = Rectangles(i4,:);
                            sign4 = 1;
                        elseif(following(r3_temp,r_flip_temp4,size)==1)
                            r4_temp = r_flip_temp4;
                            sign4 = -1;
                        else continue; %%there are no matches!
                        end
                %%%Here: there are matches, so look for them!
                if(following(r4_temp,r1_temp,size)==1)
                    %%%Found a Polygon of degree 4;
                    p_temp = [sign1*i1, sign2*i2, sign3*i3,sign4*i4];
                    Polygons = [Polygons;p_temp];
                end
                continue; %%%I only go to degree 4 polys so I end here
                     end
                
        end
    end
end


%%%NOW: CASE THAT r1 has negative orientation


for i1=1:l_rect
    %%%first the case that the first rectangle has positive orientation
    sign1 = -1;
    r1_temp = rectangle_flip(Rectangles(i1,:));
    for i2 = (i1+1):l_rect
        %%%Check if one of the orientations of the rectangle 2 agrees?
        %%%check if r
        if(following(r1_temp,Rectangles(i2,:),size)==1)
            r2_temp = Rectangles(i2,:);
            sign2 = 1;
        elseif(following(r1_temp,rectangle_flip(Rectangles(i2,:)),size)==1)
            r2_temp = rectangle_flip(Rectangles(i2,:));
            sign2 = -1;
        else continue;
        end%%there are no matches!
        %%%Now: check if this already is a match!
        if(following(r2_temp,r1_temp,size)==1)
            %%%Found a Polygon of degree 2;
            p_temp = [sign1*i1, sign2*i2, 0,0];
            Polygons = [Polygons;p_temp];
            continue;
        end%%look for another match!
        
         %%%maybe there is a polygon of degree 3?
            for i3 = (i1+1):l_rect %%%I INCREASED THE POSITION HERE, HOPE THAT'S CORRECT
                %%%%check if i3 follows r3?
                if(following(r2_temp,Rectangles(i3,:),size)==1)
                    r3_temp = Rectangles(i3,:);
                    sign3 = 1;
                elseif(following(r2_temp,rectangle_flip(Rectangles(i3,:)),size)==1)
                    r3_temp = rectangle_flip(Rectangles(i3,:));
                    sign3 = -1;
                else continue; %%there are no matches!
                end
                %%%Here: there are matches, so look for them!
                if(following(r3_temp,r1_temp,size)==1)
                    %%%Found a Polygon of degree 3;
                    p_temp = [sign1*i1, sign2*i2, sign3*i3,0];
                        Polygons = [Polygons;p_temp];
                    continue;
                end%%look for another match!
                 %%%maybe there is a polygon of degree 4?
                    
                    
                     for i4 = (i1+1):l_rect %%%I INCREASED THE POSITION HERE, HOPE THAT'S CORRECT
                %%%%check if i4 follows r3?
                        if(following(r3_temp,Rectangles(i4,:),size)==1)
                            r4_temp = Rectangles(i4,:);
                            sign4 = 1;
                        elseif(following(r3_temp,rectangle_flip(Rectangles(i4,:)),size)==1)
                            r4_temp = rectangle_flip(Rectangles(i4,:));
                            sign4 = -1;
                        else continue; %%there are no matches!
                        end
                %%%Here: there are matches, so look for them!
                if(following(r4_temp,r1_temp,size)==1)
                    %%%Found a Polygon of degree 4;
                    p_temp = [sign1*i1, sign2*i2, sign3*i3,sign4*i4];
                    Polygons = [Polygons;p_temp];
                end
                continue; %%%I only go to degree 4 polys so I end here
                     end
                
        end
    end
end



Polygons = Polygons(2:end,:);
end




%%%%%%%FLIP FUNCTION %%%maybe this function is super inefficient.
function r_flip = rectangle_flip(rectangle)
%%%Flips a rectangle
r_flip(1) = rectangle(3);
r_flip(2) = rectangle(4);
r_flip(3) = rectangle(1);
r_flip(4) = rectangle(2);
end



%%%%%%%FOLLOWING FUNCTION
function t= following(r1, r2, size)
%%%Checks if one rectangle comes after the other rectangle.
t = 0;
if(r1(2)==1)
    %%%Check if next letter and sign agrees!
    if(mod(r1(1)+1,size)==mod(r2(3),size) && r1(2) == r2(4)) 
        t = 1;
    end
elseif(r1(2)==-1)
    if(mod(r1(1)-1,size)==mod(r2(3),size) && r1(2) == r2(4)) 
        t = 1;
    end
end


end
