function R_pairs = Rectangle_Pairs(R,wordlength)


%%%%%my rectangle pairs are both facing one common centre!

%%%%Hence I want to exclude that r1 is followed by -r2 and r2 folled by
%%%%-r1.
%%%%find pairs r1, r2 of rectangles, such that 
%%%%-up to positive and negative orientation there is just one pair.
%%%%-r1 with orientation o1 is not following r2 with orientation o2 and
%%%%vice versa.
%%%%-r1 is not an inverse of the next rectangle.

%%%encoding of the rectangles pairs: [r1, s1, r2, s2];
%%%by convention, 

s_l_rect = size(R);
Number_Rectangles = s_l_rect(1);

R_pairs = [0,0,0,0];

for i1=1:Number_Rectangles
    for s1 = -1:2:1
        %%%for different signs of r1
    for i2=1:Number_Rectangles %%%%%I inserted here to make my RP start from 1 instead of i1!!
        %%%position of rectangle 2
        for s2 = -1:2:1
            %%%%check that following rectangle is not inverse and not
            %%%%following. Also that the other side is not following.
            r1_temp = R(i1,:);
            r2_temp = R(i2,:);
            if following_rectangle_is_inverse(r1_temp,s1,r2_temp,s2) == 0
                if following_rectangle_is_inverse(r2_temp,s2,r1_temp,s1) == 0
                      %%%check that none is following the other
                      if following_rectangle(r1_temp,s1,r2_temp,s2,wordlength)==0
                          if following_rectangle(r2_temp,s2,r1_temp,s1,wordlength)==0
                              %%%found a suitable pair!
                              %%%%check that if i1&i2 are the same then the
                              %%%%sign of i1 is 1
                              if or(i1 ~= i2, i1==i2 && s1 ==1)
                                R_pairs = [R_pairs; i1, s1, i2, s2];
                          end
                      end
                end
            end
        end
    end
    end
end
R_pairs = R_pairs(2:end,:);
end